package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.DataEntry;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: TransactionType
// UnionValue: SystemWriteData

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("SystemWriteData")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class SystemWriteData implements TransactionBody {
	public final TransactionType type = TransactionType.SYSTEM_WRITE_DATA;
	private DataEntry entry;
	private boolean writeToState;

    //
	public DataEntry getEntry() {
	    return entry;
	}
	public void setEntry(final DataEntry value) {
	    this.entry = value;
	}

	public SystemWriteData entry(final DataEntry value) {
	    setEntry(value);
	    return this;
	}
	public boolean getWriteToState() {
	    return writeToState;
	}
	public void setWriteToState(final boolean value) {
	    this.writeToState = value;
	}

	public SystemWriteData writeToState(final boolean value) {
	    setWriteToState(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.entry == null)) {
            marshaller.writeValue(2, entry);
        }
        if (!(!this.writeToState)) {
            marshaller.writeBool(3, this.writeToState);
        }
        return marshaller.array();
    }
}
